### Soy nuevo en GitHub y Open Source. ¿Dónde debo empezar?

Lee nuestra ["Guía de como contribuir a Open Source"](https://github.com/freeCodeCamp/how-to-contribute-to-open-source). Es una referencia completa para proyectos aptos para principiantes. E incluye muchos consejos de contribución de código abierto.

### ¿Puedo traducir recursos de freeCodeCamp?

Si -  Puedes contribuir a cualquiera de los mas de 30 idiomas que hemos habilitado en nuestra plataforma de traducción.

Tenemos las traducciones contribuidas por usuarios actualmente publicadas en chino (中文)  y español.  Tenemos la intención de traducir freeCodeCamp a los principales idiomas del mundo. Puedes leer todo sobre esto en nuestro [anuncio aquí](https://www.freecodecamp.org/news/world-language-translation-effort).

Si estas interesado en ayudar a traducir, por favor asegúrate de [leer esta guía](how-to-translate-files.md) primero.

### ¿Cómo puedo reportar un nuevo error?

Si piensas que has encontrado un error, primero lee el articulo ["Ayuda, he encontrado un error"](https://forum.freecodecamp.org/t/how-to-report-a-bug/19543) y sigue sus instrucciones.

Si estas seguro de que es un nuevo error, continúa y crea un nuevo tema de GitHub. Asegúrate de incluir tanta información como sea posible para que podamos reproducir el error.  Disponemos de una plantilla de temas predefinida para ayudarte con esto.

Ten en cuenta que estos temas de GitHub son para discusiones y problemas relacionados con la base de código, no para obtener ayuda para aprender a codificar. Cuando tengas dudas, deberías [buscar asistencia en el foro](https://forum.freecodecamp.org) antes de crear un tema en GitHub.

### ¿Cómo puedo informar sobre un problema de seguridad?

Por favor, no crees temas en GitHub por problemas de seguridad. En su lugar, envía un correo electrónico a  `security@freecodecamp.org` y lo investigaremos inmediatamente.

### Soy un estudiante. ¿Puedo trabajar en una funcionalidad para créditos académicos?

Si. Por favor, ten en cuenta que no podemos encomendar ningún plazo o documentos que puedan ser requeridos por tu colegio o universidad. Recibimos muchas pull-requests y contribuciones de código por parte de desarrolladores voluntarios, y respetamos su tiempo y esfuerzos. Por respeto a todos nuestros otros colaboradores, nosotros no daremos ninguna prioridad especial a las relaciones públicas solo porque esté relacionado con una escuela.

Te solicitamos que planifiques con anticipación y trabajes contribuyendo en el código con esto en mente.

### ¿Qué significan estas diferentes etiquetas que están agregadas en los temas?

Los mantenedores de código [clasifican](https://en.wikipedia.org/wiki/Software_bug#Bug_management) problemas y solicitudes de extracción en función de su prioridad, gravedad y otros factores. Puedes encontrar [un glosario completo con sus significados aquí](https://github.com/freecodecamp/freecodecamp/labels).

### ¿Dónde comienzo si quiero trabajar en una propuesta?

Debes ir a través de [**`help wanted`**](https://github.com/freeCodeCamp/freeCodeCamp/issues?q=is%3Aopen+is%3Aissue+label%3A%22help+wanted%22) o cuestiones [**`first timers only`**](https://github.com/freeCodeCamp/freeCodeCamp/issues?q=is%3Aopen+is%3Aissue+label%3A%22first+timers+only%22) para una visión general rápida de lo que está disponible para trabajar.

> [!TIP] Los temas de **`se busca ayuda`** están en marcha y no es necesario pedir permiso antes de trabajar en ellos. Sin embargo, temas con la etiqueta **`solo principiantes`** son temas especiales que están diseñados para personas que no han contribuido a la base de código de freeCodeCamp antes.

### Encontré un error tipográfico. ¿Debo informar de un problema antes de poder hacer un pull request?

Por errores tipográficos y cambios de palabras, puede abrir directamente pull requests sin crear un tema antes. Por favor, asegúrate de mencionar los detalles en la descripción del pull request para ayudarnos a entender y revisar tu contribución, incluso si es un cambio menor.

Por favor crea un tema si deseas discutir aspectos más amplios del código base o del currículo.

### ¿Cómo puedo conseguir que me asignen un tema?

Por lo general, no asignamos los temas a nadie más que a los colaboradores con mucha antigüedad. En lugar de ello, seguimos la política siguiente para ser justos con todos:

1. Lo más probable es que fusionemos el primer pull request que aborde el tema o problema.
2. En el caso de múltiples colaboradores abriendo un pull request para el mismo problema más o menos al mismo tiempo, daremos prioridad al pull request que aborde mejor la cuestión. Algunas de las cosas que consideramos:
   - ¿Has incluido pruebas?
   - ¿Has detectado todos los casos de usos?
   - ¿Te aseguraste de que pasaran todas las pruebas, y confirmaste que todo funciona localmente?
3. Por último, damos prioridad a los pull requests que siguen nuestras directrices recomendadas.
   - ¿Has seguido la lista de verificación de pull request?
   - ¿Has dado a tu pull request un título significativo?

### Estoy atascado en algo que no está incluido en esta documentación.

**Eres bienvenido a pedir ayuda en:**

- La categoría de `Colaboradores` de [nuestro foro de la comunidad](https://forum.freecodecamp.org/c/contributors).
- El canal `#Contributors` en [nuestro servidor de chat](https://chat.freecodecamp.org/channel/contributors).

Estamos emocionados de poder ayudarte a contribuir en cualquier tema en el que te gustaría trabajar. Si nos haces preguntas en los hilos de conversación de los temas relacionados, estaremos encantados de clarificar las cosas. Asegúrate de buscar tu pregunta antes de publicar una nueva.

Gracias de antemano por ser amable y paciente. Recuerda, esta comunidad es manejada principalmente por voluntarios.

### Asistencia adicional

Si tiene preguntas sobre el stack, la arquitectura del código base, las traducciones o cualquier otra cosa, no dude en comunicarse con nuestro personal.

| Personal              | Enviar mensaje en el Foro                                                    |
|:--------------------- |:---------------------------------------------------------------------------- |
| Ahmad Abdolsaheb      | [@abdolsa](https://forum.freecodecamp.org/u/abdolsa)                         |
| Kristofer Koishigawa  | [@scissorsneedfoodtoo](https://forum.freecodecamp.org/u/scissorsneedfoodtoo) |
| Miya Liu              | [@miyaliu](https://chinese.freecodecamp.org/forum/u/miyaliu)                 |
| Mrugesh Mohapatra     | [@raisedadead](https://forum.freecodecamp.org/u/raisedadead)                 |
| Nicholas Carrigan     | [@nhcarrigan](https://forum.freecodecamp.org/u/nhcarrigan)                   |
| Oliver Eyton-Williams | [@ojeytonwilliams](https://forum.freecodecamp.org/u/ojeytonwilliams)         |
| Rafael D Hernandez    | [@RafaelHernandez](https://forum.freecodecamp.org/u/rafaelhernandez)         |
| Shaun Hamilton        | [@sky020](https://forum.freecodecamp.org/u/sky020)                           |
| Tom Mondloc           | [@moT01](https://forum.freecodecamp.org/u/moT01)                             |

**Puedes enviar un correo electrónico a nuestro equipo de desarrolladores en: `dev[at]freecodecamp.org`**
