# Como revisar as traduções

Nossa equipe de revisão é responsável por garantir que as traduções reflitam com exatidão o texto original. Confiamos em nossos revisores para que tenhamos traduções de alta qualidade.

Todas as nossas traduções são feitas a mão, por humanos reais. A revisão mantém um tom consistente em todos os nossos recursos traduzidos, como o currículo.

Para iniciar a revisão, visite [nossa plataforma de tradução](https://translate.freecodecamp.org) e faça o login. Selecione "Go to console" na barra de navegação superior para mudar da visualização pública para a visualização do espaço de trabalho.

## Selecione um arquivo

Você deve ver a lista de projetos aos quais foi concedido acesso. Selecione o projeto que você gostaria de revisar e, em seguida, selecione o idioma.

![Imagem - Estrutura dos arquivos de revisão](https://contribute.freecodecamp.org/images/crowdin/proof-file-tree.png)

Agora você deve ver a lista de arquivos disponíveis. Escolha seu arquivo selecionando o botão `Proofread` à direita do arquivo, depois escolha `Proofreading` no menu que aparece.

> [!NOTE] Se você estiver nesta visão de espaço de trabalho, mas quiser [traduzir um arquivo](how-to-translate-files.md) em vez de revisar, você pode selecionar `Crowdsourcing` no menu suspenso.

## Traduções revisadas

![Imagem - Visualização da Revisão](https://contribute.freecodecamp.org/images/crowdin/proofread.png)

<!--Add proofread/crowdsource button to the image-->

Aqui você verá a lista de strings do arquivo selecionado, com suas respectivas traduções. A tradução que é exibida aqui é a tradução que recebeu a maior pontuação (entre votos positivos e negativos) da comunidade de tradução.

Enquanto você pode ver _todas_ as traduções propostas para uma determinada string, a pontuação da comunidade (determinada pelos votos positivos e negativos) deve ser levada em consideração na escolha da tradução a ser aprovada. A comunidade pode revisar as traduções propostas e recomendar qual delas é a mais precisa e clara.

1. Esta é a string original (em inglês).
2. Esta é a string de tradução correspondente. A proposta de tradução mais popular, baseada em votos a favor e contra, será exibida aqui.
3. Clicando neste botão de verificação, a tradução será aprovada.
4. Crowdin exibirá o estado de cada string. `Done` significa que uma tradução foi aprovada e será baixada em nosso próximo Crowdin pull. `Todo` significa que a string não foi revisada. `Hidden` significa que a string está bloqueada e _não deve ser traduzida_. `Comment` significa que a string tem um comentário relacionado.
5. As traduções podem ser selecionadas com as caixas de seleção e aprovadas aqui com uma única ação.
6. Você pode ver as traduções propostas pela comunidade, suas pontuações de popularidade, e traduções sugeridas pela Crowdin aqui.
7. Este botão mostra/esconde o painel do lado direito, onde você pode ver traduções, comentários, memória de tradução e termos do glossário.
8. Crowdin exibe aqui mensagens de erro a partir das verificações de garantia de qualidade. Em outras palavras, se algo não parecer correto na tradução, o Crowdin notificará você. Estas traduções devem ser aprovadas com cuidado.

Nenhuma ação adicional é necessária quando o arquivo terminou de ser revisado.

> [!NOTE] A aprovação de uma string na visualização de revisão a marcará como completa e será baixada em nosso próximo pull da Crowdin para o GitHub.

## Tornando-se um revisor

Se você tiver qualquer dúvida, ou estiver interessado em se tornar um revisor, sinta-se a vontade em nos enviar uma mensagem no nosso [ chat de contribuidores](https://chat.freecodecamp.org/channel/contributors). Vamos te dar acesso se você já estiver contribuindo para freeCodeCamp por um tempo.

Nosso time de desenvolvedores e times de moderadores da comunidade está sempre procurando por voluntários gentis como você, que nos ajuda a deixar traduções de alta qualidade disponíveis para o mundo.

> [!NOTE] O Crowdin permitirá que você aprove suas traduções. Em geral, é melhor permitir que outro revisor reveja suas traduções propostas como segurança extra para garantir que não haja erros.

## Criando um canal no chat para um idioma

Para a maior parte das mensagens, encorajamos você a usar o [chat de contribuidores](https://chat.freecodecamp.org/channel/contributors) para todas as interações. Entretanto, se o time de voluntários crescer para um idioma específico, nós consideramos criar um canal adicional para o idioma.

Se você já é um revisor e está interessado em ter um canal dedicado a um idioma específico, [preencha nosso formulário](https://forms.gle/XU5CyutrYCgDYaVZA).
